% Copyright (C) 2011 - Michael Baudin
%
% This file must be used under the terms of the 
% Creative Commons Attribution-ShareAlike 3.0 Unported License :
% http://creativecommons.org/licenses/by-sa/3.0/

\documentclass[12pt]{article}

\include{macros}

\begin{document}

\title{Error bounds of complex arithmetic}
\date{June 2011}
\author{Michael Baudin}

\maketitle

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{abstract}
In this document, we present error bounds for the complex arithmetic. 
We present the error bounds which are presented in the biliography. 
We give the proof of some error bounds for the complex addition, multiplication 
and division. 
A new proof for the error bound associated with the complex division is presented. 
This proof leads to an error bound which is smaller than other published bounds.
\end{abstract}

\tableofcontents

\newpage
$\textrm{ }$
\vfill
Copyright \copyright{} 2011 - Michael Baudin

This file must be used under the terms of the 
Creative Commons Attribution-ShareAlike 3.0 Unported License:
\begin{center}
\url{http://creativecommons.org/licenses/by-sa/3.0}
\end{center}

\newpage

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Introduction}
We present in this section the parameters of the floating point 
numbers which are used in Scilab, that is, we present binary 64 doubles.

In Scilab, we use double precision floating point numbers, which  
corresponds to the binary 64 floating point numbers of the IEEE-2008 
\cite{P754:2008:ISF} standard. 
In this floating point system, the significand makes use 
of $p=53$ binary digits of precision and 11 binary digits in the exponent. 
The parameter of the IEEE 754 double precision floating point 
system are presented in the figure~\ref{fig-doubles-properties}.

The benefits of the IEEE 754 2008 standard \cite{P754:2008:ISF} is that it 
increases the portability of programs which are making use of floating point numbers, 
and especially those written in the Scilab language. 
Indeed, on all machines where Scilab is available, the radix, the precision and 
the number of bits in the exponent are the same. 
As a consequence, the machine epsilon $\epsilon$ is always equal 
to the same value for doubles.
This is the same for the largest positive normal $\Omega$ and 
the smallest positive normal $\mu$, which are always 
equal to the values presented in the figure \ref{fig-doubles-properties}.
The situation for the smallest positive subnormal $\alpha$ is more complex, 
but, in this paper, we assume that gradual underflow is available.

\begin{figure}
\begin{center}
\begin{tabular}{|ll|}
\hline
Radix $\beta$ & 2  \\
Precision $p$ & 53 \\
Exponent Bits & 11 \\
Minimum Exponent $e_{min}$ & -1022 \\
Maximum Exponent $e_{max}$ & 1023 \\
Largest Positive Normal $\Omega$ & $\left(2-2^{-52}\right)\cdot 2^{1023} \approx 1.79\times 10^{308}$ \\
Smallest Positive Normal $\mu$ & $2^{-1022} \approx 2.22\times 10^{-308}$ \\
Smallest Positive Subnormal $\alpha$ & $2^{-1074} \approx 4.94\times 10^{324}$ \\
Epsilon $\epsilon$ & $2^{-52} \approx 2.220\times 10^{-16}$ \\
Unit roundoff $u$ & $2^{-53} \approx 1.110\times 10^{-16}$ \\
\hline
\end{tabular}
\end{center}
\caption{Scilab IEEE 754 doubles}
\label{fig-doubles-properties}
\end{figure}

Doubles have intrinsic limitations which can lead to 
rounding, overflow or underflow. 
Indeed, not all mathematical numbers $x$ 
can be represented as floating point numbers. 
We denoted by $fl(x)$ the floating point representation of $x$. 
In this paper, we are mostly concerned with overflow and 
underflow. 
Indeed, if $x$ is a number such that $|x|<\alpha$, 
then the floating point representation of $x$ is 
$fl(x)=0$, i.e. $x$ underflows. 
On the other hand, if $x$ is a number such that $|x|>\Omega$, 
then the floating point representation of $x$ is 
$fl(x)=Inf$, i.e. $x$ overflows.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Useful results for error bounds}
\label{section-ureb}

In this section, we derive propositions wich are 
useful in the context of error analysis. 
These results are presented by Higham \cite{Higham:2002:ASN}.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Properties of $\gamma_n$}

In this section, we assume that $u$, the unit roundoff, 
is a positive real number such that $0<u<1$. 
The unit roundoff is half the machine epsilon, i.e. $u=\frac{1}{2}\epsilon$.

\begin{definition}
(\emph{Gamma-n})
For $n=1,2,\ldots$ such that $nu< 1$, let us define $\gamma_n$ by 
\begin{eqnarray}
\label{def-gamman}
\gamma_n = \frac{nu}{1-nu}.
\end{eqnarray}
\end{definition}

The table \ref{fig-tableu} presents a 
table of approximations of the ratio $\frac{\gamma_n}{nu}$, for 
increasing values of $n$. 
For $n\leq 10^{15}$, we have $\gamma_n \leq 1.13 nu$.

\begin{figure}
\begin{center}
\begin{tabular}{|ll|ll|}
\hline
$n$ & $\frac{\gamma_n}{nu}$ & $n$ & $\frac{\gamma_n}{nu}$ \\
\hline
1 & 1.00000000000000020 & $10^{1}$ & 1.00000000000000110\\
2 & 1.00000000000000020 & $10^{2}$ & 1.00000000000001110\\
3 & 1.00000000000000020 & $10^{3}$ & 1.00000000000011100\\
4 & 1.00000000000000040 & $10^{4}$ & 1.00000000000111020\\
5 & 1.00000000000000040 & $10^{5}$ & 1.00000000001110220\\
6 & 1.00000000000000070 & $10^{6}$ & 1.00000000011102230\\
7 & 1.00000000000000070 & $10^{7}$ & 1.00000000111022300\\
8 & 1.00000000000000090 & $10^{8}$ & 1.00000001110223050\\
9 & 1.00000000000000090 & $10^{9}$ & 1.00000011102231490\\
10 & 1.00000000000000110 & $10^{10}$ & 1.00000111022425720\\
11 & 1.00000000000000130 & $10^{11}$ & 1.00001110235350700\\
12 & 1.00000000000000130 & $10^{12}$ & 1.00011103462978280\\
13 & 1.00000000000000160 & $10^{13}$ & 1.00111145698976610\\
14 & 1.00000000000000160 & $10^{14}$ & 1.01122687358170120\\
15 & 1.00000000000000160 & $10^{15}$ & 1.12488761278269790\\
\hline
\end{tabular}
\end{center}
\caption{
Approximations of $\frac{\gamma_n}{nu}$ to 17 decimal digits. 
We consider the unit roundoff $u$ which corresponds to binary 64 (double precision) 
floating point numbers.
}
\label{fig-tableu}
\end{figure}

The following \scivar{gamman} function returns $\gamma_n$ which 
corresponds to the given $n$.
\lstset{language=scilabscript}
\begin{lstlisting}
function y = gamman(n)
  u=%eps/2
  y = (n.*u)./(1-n.*u)
endfunction
\end{lstlisting}

In the following session, we compute the unit roundoff $u$ and 
compute the ratio $\gamma_n/u$ for increasing values of $n$.
\lstset{language=scilabscript}
\begin{lstlisting}
-->u=%eps/2
 u  =
    1.110D-16  
-->[n gamman(n)/u]
 ans  =
    1.           1.         
    16.          16.        
    256.         256.       
    4096.        4096.      
    65536.       65536.     
    1048576.     1048576.   
    16777216.    16777216.  
    2.684D+08    2.684D+08  
    4.295D+09    4.295D+09  
    6.872D+10    6.872D+10  
    1.100D+12    1.100D+12  
    1.759D+13    1.763D+13  
    2.815D+14    2.906D+14  
    4.504D+15    9.007D+15  
\end{lstlisting}

Notice that the equality \ref{def-gamman} can be applied even if $n$ is a 
real number greater than 1. 
In some results that we are going to derive, we will consider real numbers $n$, 
as this does not change the definition. 

In this section, we will use regularily the following result from calculus 
which describes the geometric series. 

\begin{proposition}
(\emph{Geometric series})
\label{prop-inverse}
Assume that $x\in\RR$ is such that $|x|< 1$. 
Therefore, 
\begin{eqnarray}
\label{def-geometricseries}
\frac{1}{1-x} = 1 + x + x^2 + x^3 + x^4 + \ldots
\end{eqnarray}
\end{proposition}

Before entering into more complex developments, let us consider 
more elementary properties of $\gamma_n$. 

\begin{proposition}
(\emph{Basic properties of $\gamma_n$})
\label{prop-basicgamman}
Assume that $j,k,n\in\RR$ are three real numbers such that $j,k,n\geq 1$ and $ju,ku,nu< 1$. 
If $j\leq k$, then 
\begin{eqnarray}
\label{eq-basicgamman1}
\gamma_j \leq \gamma_k
\end{eqnarray}
If $jku < 1$, then 
\begin{eqnarray}
\label{eq-basicgamman3}
j \gamma_k \leq \gamma_{jk}.
\end{eqnarray}
\end{proposition}

Notice that we have chosen to consider the case where $j,k,n$ are real 
numbers instead of the more restrictive case where they are integers. 
As we are going to see, this does not change anything to the results that we 
are going to prove. 

\begin{proof}
We first prove the inequality \ref{eq-basicgamman1}. 
Assume that $j\leq k$. 
Since $u>0$, we have
\begin{eqnarray}
\label{eq-basicgamman4}
ju \leq ku. 
\end{eqnarray}
The hypothesis $ju<1$ implies that $1-ju$ is positive, hence we can 
multiply both sides of the previous inequality by $\frac{1}{1-ju}$ and get
\begin{eqnarray}
\label{eq-basicgamman5}
\frac{ju}{1-ju} \leq \frac{ku}{1-ju}.
\end{eqnarray}
In turn, this implies $-ju\geq -ku$, which implies 
$1-ju \geq 1-ku$. 
The hypothesis $ku<1$ implies that $1-ku >0$, which 
allows to invert the inequality and implies 
\begin{eqnarray}
\label{eq-basicgamman6}
\frac{1}{1-ju} \leq \frac{1}{1-ku}.
\end{eqnarray}
We plug the inequality \ref{eq-basicgamman6} into \ref{eq-basicgamman5} and get 
\begin{eqnarray}
\label{eq-basicgamman7}
\frac{ju}{1-ju} \leq \frac{ku}{1-ku},
\end{eqnarray}
which immediately leads to the inequality \ref{eq-basicgamman1}.

We now prove the inequality \ref{eq-basicgamman3}. 
We have 
\begin{eqnarray}
\label{eq-basicgamman8}
j \gamma_k  = \frac{jku}{1-ku}.
\end{eqnarray}
The hypothesis $j\geq 1$ implies $k \leq kj$. 
Then the inequality $u>0$ implies $ku \leq jku$. 
Hence $1-ku \geq 1-jku$. 
The hypothesis $jku < 1$ implies that $1-jku > 0$. 
Hence, we can invert the previous inequality, which implies 
\begin{eqnarray}
\label{eq-basicgamman9}
\frac{1}{1-ku} \leq \frac{1}{1-jku}.
\end{eqnarray}
We plug the inequality \ref{eq-basicgamman9} into \ref{eq-basicgamman8}, 
which implies 
\begin{eqnarray}
\label{eq-basicgamman10}
j \gamma_k  \leq \frac{jku}{1-jku}.
\end{eqnarray}
Then, the definition of $\gamma_{jk}$ concludes the proof.
\end{proof}


In most error analysis, we are considering terms of the form 
$1+\delta$, where $\delta$ is a relative error of small magnitude, 
i.e. such that $|\delta|\leq u$.
In the following proposition, we prove that terms $1+\delta_i$ can 
be expressed as $1+\theta_n$, where $\theta_n$ is only slightly 
larger than $nu$.

\begin{proposition}
(\emph{Bound for a product of $(1+\delta_i)$})
\label{prop-productdelta}
Assume that $n=1,2,\ldots$ is such that $nu< 1$. 
Assume that $\delta_i \in \RR$ is such that $|\delta_i|\leq u$, 
for $i=1,2,\ldots,n$.
Then there exists a $\theta_n\in\RR$ such that 
\begin{eqnarray}
\label{def-deltaprod}
(1+\delta_1)(1+\delta_2)\cdots(1+\delta_n) = 1 + \theta_n,
\end{eqnarray}
where
\begin{eqnarray}
\label{def-deltaprodtheta}
|\theta_n| \leq \gamma_n,
\end{eqnarray}
and where $\gamma_n$ is defined by \ref{def-gamman}.
\end{proposition}

\begin{proof}
We first check that this proposition is true for $n=1$ and 
$n=2$. 

It is easy to check this proposition for $n=1$. 
We assume that $\delta_1\in\RR$ is such that $|\delta_1|\leq u$.
Then $1+\delta_1= 1 + \theta_1$, with $\theta_1=\delta_1$. 
Moreover, $|\theta_1|=|\delta_1|\leq u$. 
But $u>0$, by hypothesis. 
Therefore, $-u<0$, which implies $1-u<1$. 
Hence, $1<\frac{1}{1-u}$. 
This leads to $|\theta_1|\leq u\leq \frac{u}{1-u}$. 

We can also check this proposition for $n=2$. 
We assume that $\delta_i\in\RR$ is such that $|\delta_i|\leq u$, 
for $i=1,2$.
We have 
\begin{eqnarray}
\label{def-deltaprod1}
(1+\delta_1)(1+\delta_2) = 1 + \delta_1 + \delta_2 + \delta_1 \delta_2.
\end{eqnarray}
Hence, 
\begin{eqnarray}
\label{def-deltaprod2}
(1+\delta_1)(1+\delta_2) = 1 + \theta_2,
\end{eqnarray}
where $\theta_2 = \delta_1 + \delta_2 + \delta_1 \delta_2$.
We have to prove that $|\theta_2|\leq \gamma_2$.
We consider the absolute value of $\theta_2|$, and get
\begin{eqnarray}
\label{def-deltaprod4}
|\theta_2| 
&\leq& |\delta_1| + |\delta_2| + |\delta_1| |\delta_2| \\
&\leq& u + u + u u \\
&\leq& 2u + u^2 \\
&\leq& 2u(1 + \frac{u}{2}).
\end{eqnarray}
We can conclude if we can prove that $1+\frac{u}{2}\leq \frac{1}{1-2u}$. 
But this is true, since
\begin{eqnarray}
\label{def-deltaprod5}
1 + \frac{u}{2}
&\leq & 1+2u \\
&\leq & 1+2u+(2u)^2+(2u)^3+\ldots \\
&\leq & \frac{1}{1-2u},
\end{eqnarray}
since, by hypothesis, $2u<1$. 
This concludes the proof for the case $n=2$.

In order to prove the general case, we proceed by induction on $n$. 
Let us assume that \ref{def-deltaprod} is true for $n$, and let 
us prove that it is true for $n+1$. 
Let us denote the products of $n$ terms $1+\delta_i$ by $P_n$, 
i.e. let $P_n$ be defined by  
\begin{eqnarray}
\label{def-deltaprodPn}
P_n = (1+\delta_1)(1+\delta_2)\cdots(1+\delta_n).
\end{eqnarray}
Hence 
\begin{eqnarray}
\label{def-deltaprodPn3}
P_{n+1} 
&=& P_n (1+\delta_{n+1}).
\end{eqnarray}
By hypothesis, $P_n = 1 + \theta_n$,
where $|\theta_n|\leq \gamma_n$.
Hence, 
\begin{eqnarray}
\label{def-deltaprodPn4}
P_{n+1} 
&=& (1 + \theta_n) (1+\delta_{n+1}) \\
&=& 1+\delta_{n+1} + \theta_n (1+\delta_{n+1}).
\end{eqnarray}
Let us define $\theta_{n+1}$ by 
\begin{eqnarray}
\label{def-deltaprodPn5}
\theta_{n+1}
&=& \delta_{n+1} + \theta_n (1+\delta_{n+1}).
\end{eqnarray}
Then we have $P_{n+1} = 1+\theta_{n+1}$ and 
we must proove that $|\theta_{n+1}|\leq \gamma_{n+1}$. 
We have
\begin{eqnarray}
\label{def-deltaprodPn6}
|\theta_{n+1}|
&\leq& |\delta_{n+1}| + |\theta_n| |1+\delta_{n+1}| \\
&\leq& u + \gamma_n (1+|\delta_{n+1}|) \\
&\leq& u + \frac{nu}{1-nu} (1+u).
\end{eqnarray}
It is easy to simplify this fraction, which leads to
\begin{eqnarray}
\label{def-deltaprodPn6b}
u + \frac{nu}{1-nu} (1+u)
&=& \frac{u(1-nu) + nu(1+u)}{1-nu}\\
&=& \frac{u -nu^2 + nu+nu^2}{1-nu}\\
&=& \frac{u + nu}{1-nu}\\
&=& \frac{(n+1)u}{1-nu}.
\end{eqnarray}
Therefore,
\begin{eqnarray}
|\theta_{n+1}|
&\leq& \frac{(n+1)u}{1-nu}.  \label{def-deltaprodPn6c}
\end{eqnarray}
By hypothesis, we have $0<nu<(n+1)u<1$, which implies
\begin{eqnarray}
\label{def-deltaprodPn7}
0 < \frac{1}{1-nu} < \frac{1}{1-(n+1)u} < 1.
\end{eqnarray}
We plug the inequality \ref{def-deltaprodPn7} into 
\ref{def-deltaprodPn6c}, and get:
\begin{eqnarray}
\label{def-deltaprodPn8}
|\theta_{n+1}|
&\leq& \frac{(n+1)u}{1-(n+1)u},
\end{eqnarray}
which concludes the proof.
\end{proof}

As suggested by the proposition \ref{prop-productdelta}, 
$\gamma_n$ plays an important role in the derivation of 
error bounds. 
Indeed, it is useful to have intermediate proposition on the 
properties of $\gamma_n$ which simplifies these derivations. 

\begin{proposition}
(\emph{Sums of $\gamma_n$})
\label{prop-gammansum}
Assume that $n=1,2,\ldots$ is such that $nu< 1$. 
Then,
\begin{eqnarray}
\label{eq-gammansum}
\gamma_j + \gamma_k + \gamma_j \gamma_k \leq  \gamma_{j+k},
\end{eqnarray}
for any $j,k=1,2,\ldots$, such that $ju<1$, $ku<1$ and $(j+k)u<1$.
\end{proposition}

Since $\gamma_j \gamma_k > 0$, the previous inequality 
proves the simpler inequality s
\begin{eqnarray}
\label{eq-gammansumb}
\gamma_j + \gamma_k \leq  \gamma_{j+k}.
\end{eqnarray}
We emphasize that the previous inequality is relatively sharp, because 
both $\gamma_j$ and $\gamma_k$ are much smaller than 1 in practice. 
Hence, in practice, the product $\gamma_j \gamma_k$ can be neglected 
compared to $\gamma_j$ or $\gamma_k$. 

We notice that $1<\frac{1}{1-u}$, since $u<1$. 
Therefore, $u<\frac{u}{1-u}=\gamma_1$. 
The inequality \ref{eq-gammansumb} then implies 
\begin{eqnarray}
\label{eq-gammansumbb}
\gamma_j + u < \gamma_j + \gamma_1 \leq  \gamma_{j+1}.
\end{eqnarray}
The previous inequality can be used in some situations. 

\begin{proof}
To derive this inequality, we brutally expand the expressions and 
try to express the result depending on $j+k$.
From the definition \ref{def-gamman}, we get:
\begin{eqnarray}
\label{eq-gammansum1}
\gamma_j + \gamma_k + \gamma_j \gamma_k 
&=& \frac{ju}{1-ju} + \frac{ku}{1-ku} + \frac{ju}{1-ju} \frac{ku}{1-ku} \\
&=& \frac{ju(1-ku) + ku(1-ju)+(ju)(ku)}{(1-ju)(1-ku)} \\
&=& \frac{ju - jku^2 + ku - jku^2 +jku^2}{1-ju-ku+jku^2} \\
&=& \frac{ju + ku - jku^2}{1-(j+k)u+jku^2} \\
&=& \frac{(j+k)u - jku^2}{1-(j+k)u+jku^2}. \label{eq-gammansum2}
\end{eqnarray}
On one hand, we have $-jku^2\leq 0$, which implies 
\begin{eqnarray}
(j+k)u - jku^2 \leq (j+k)u. \label{eq-gammansum3}
\end{eqnarray}
One the other hand, we have $jku^2 \geq 0$, which implies 
\begin{eqnarray}
1-(j+k)u+jku^2 \geq 1-(j+k)u.
\end{eqnarray}
The hypothesis $(j+k)u<1$ implies that both sides of the previous 
equation are greater than zero. 
Hence, we can invert the inequality and get
\begin{eqnarray}
\frac{1}{1-(j+k)u+jku^2} \leq \frac{1}{1-(j+k)u}. \label{eq-gammansum4}
\end{eqnarray}
We plug the inequalities \ref{eq-gammansum3} and \ref{eq-gammansum4} 
into \ref{eq-gammansum2}, and get
\begin{eqnarray}
\gamma_j + \gamma_k + \gamma_j \gamma_k \leq  \gamma_{j+k}
\leq \frac{(j+k)u}{1-(j+k)u},
\end{eqnarray}
which concludes the proof.
\end{proof}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Properties of $\theta_j$}

When two expressions are multiplied in an arithmetic operation, 
this leads to an error in the form of $(1+\theta_j)(1+\theta_k)$. 
The proposition \ref{prop-gammansum} can be used to express 
these products, as shown in the following proposition.

\begin{proposition}
(\emph{The product of two $(1+\theta_j)$s})
\label{prop-thetajkprod}
Assume that $n=1,2,\ldots$ is such that $nu< 1$. 
Assume that $\theta_j \in\RR$ is such that $|\theta_j|\leq \gamma_j$, 
for $j=1,2,\ldots$, where $\gamma_j$ is defined by \ref{def-gamman}.
Then,
\begin{eqnarray}
\label{eq-thetajkprod}
(1+\theta_j)(1+\theta_k) \leq 1+\theta_{j+k},
\end{eqnarray}
for any $j,k=1,2,\ldots$, such that $ju<1$, $ku<1$ and $(j+k)u<1$.
\end{proposition}

\begin{proof}
Indeed, we have 
\begin{eqnarray}
(1+\theta_j)(1+\theta_k) 
&=& 1 + \theta_j + \theta_k + \theta_j\theta_k. \label{eq-thetajkprod1}
\end{eqnarray}
The previous equation can be written as $(1+\theta_j)(1+\theta_k) = 1 + \theta_{j+k}$,
where $\theta_{j+k}$ is defined by 
\begin{eqnarray}
\theta_{j+k}
&=& \theta_j + \theta_k + \theta_j\theta_k. \label{eq-thetajkprod2}
\end{eqnarray}
In order to conclude the proof, we now have to prove 
that $|\theta_{j+k}|\leq \gamma_{j+k}$.
This is easy since, by hypothesis, 
\begin{eqnarray}
|\theta_{j+k}|
&\leq & |\theta_j| + |\theta_k| + |\theta_j||\theta_k| \\
&\leq & \gamma_j| + \gamma_k + \gamma_j \gamma_k.
\end{eqnarray}
We then apply the proposition \ref{prop-gammansum}, 
which immediately concludes the proof.
\end{proof}

It may happen that an arithmetic operation leads to the 
sum of two expression, which may lead to an expression 
such as $a(1+\theta_n) + b(1+\theta_n)$, for some real 
numbers $a$ and $b$. 
The following proposition can be used in these cases.

\begin{proposition}
(\emph{Linear combination of $\theta_j$s (part 1)})
\label{prop-thetajksum}
Assume that $j=1,2,\ldots$ is such that $ju< 1$. 
Assume that $\theta_j,\theta^\prime_j \in\RR$ are such 
that $|\theta_j|,|\theta^\prime_j|\leq \gamma_j$ 
where $\gamma_j$ is defined by \ref{def-gamman}.
Assume that $a,b\in \RR$. 
Therefore, 
\begin{eqnarray}
\label{eq-thetajksum}
a\theta_j + b \theta^\prime_j  = (|a|+|b|) \theta^{\prime\prime}_j,
\end{eqnarray}
for some $\theta^{\prime\prime}_j$ which satisfies 
$|\theta^{\prime\prime}_j|\leq \gamma_j$.
\end{proposition}

\begin{proof}
If $|a|+|b|=0$, then the proposition is proved trivially, since both $a$ and 
$b$ are zero. 
Let us assume that $|a|+|b|\neq 0$ and let us define 
\begin{eqnarray}
\theta^{\prime\prime}_j
= \frac{a\theta_j + b \theta^\prime_j}{|a|+|b|}.
\end{eqnarray}
We have 
\begin{eqnarray}
|\theta^{\prime\prime}_j|
&=& \left| \frac{a\theta_j + b \theta^\prime_j}{|a|+|b|}\right| \\
&\leq& \frac{|a||\theta_j| + |b| |\theta^\prime_j|}{|a|+|b|} \\
&\leq& \frac{|a| \gamma_j  + |b| \gamma_j}{|a|+|b|} \\
&\leq&  \gamma_j,
\end{eqnarray}
which concludes the proof.
\end{proof}

We can apply the proposition \ref{prop-thetajksum} in the particular 
case where both $a$ and $b$ are positive.
In this case, we have 
\begin{eqnarray}
a (1+\theta_j) + b (1+\theta^\prime_j)
&=&a+b+a\theta_j + b \theta^\prime_j \\
&=&a+b+(a+b) \theta^{\prime\prime}_j,
\end{eqnarray}
since $|a|=a$ and $|b|=b$.
Therefore, 
\begin{eqnarray}
a (1+\theta_j) + b (1+\theta^\prime_j)
&=&(a+b) (1+ \theta^{\prime\prime}_j),
\end{eqnarray}
which leads to the following proposition.

\begin{proposition}
(\emph{Combination of $1+\theta_j$s} (part 2))
\label{prop-thetajksum-bis}
Assume that $j=1,2,\ldots$ is such that $ju< 1$. 
Assume that $\theta_j,\theta^\prime_j \in\RR$ is such 
that $|\theta^\prime_j|,|\theta_j|\leq \gamma_j$, 
where $\gamma_j$ is defined by \ref{def-gamman}.
Assume that $a,b\geq 0$. 
Therefore, 
\begin{eqnarray}
\label{eq-thetajksumbis}
a(1+\theta_j) + b (1+\theta^\prime_j)  = (a+b) (1+\theta^{\prime\prime}_j),
\end{eqnarray}
for some $\theta^{\prime\prime}_j$ which satisfies 
$|\theta^{\prime\prime}_j|\leq \gamma_j$.
\end{proposition}

\begin{proof}
If $|a|+|b|=0$, then the proposition is proved trivially, since both $a$ and 
$b$ are zero. 
Let us assume that $|a|+|b|\neq 0$ and let us define 
\begin{eqnarray}
\label{eq-thetajksum1}
\theta^{\prime\prime}_j
= \frac{a\theta_j + b \theta^\prime_j}{|a|+|b|}.
\end{eqnarray}
We have 
\begin{eqnarray}
\label{eq-thetajksum2}
|\theta^{\prime\prime}_j|
&=& \left| \frac{a\theta_j + b \theta^\prime_j}{|a|+|b|}\right| \\
&\leq& \frac{|a||\theta_j| + |b| |\theta^\prime_j|}{|a|+|b|} \\
&\leq& \frac{|a| \gamma_j  + |b| \gamma_j}{|a|+|b|} \\
&\leq&  \gamma_j,
\end{eqnarray}
which concludes the proof.
\end{proof}


\begin{proposition}
(\emph{Linear combination of $\theta_j$s (part 3)})
\label{prop-thetajksum-ter}
Assume that $j,k=1,2,\ldots$ is such that $ju< 1$ and $ku< 1$. 
Assume that $\theta_j,\theta_k \in\RR$ are such 
that $|\theta_j|\leq \gamma_j$ and $|\theta_k|\leq \gamma_k$
where $\gamma_j$ is defined by \ref{def-gamman}.
Assume that $a,b\in \RR$. 
Therefore, 
\begin{eqnarray}
\label{eq-thetajksumter}
a\theta_j + b \theta_k  = (|a|+|b|) \theta_{j+k},
\end{eqnarray}
for some $\theta_{j+k}$ which satisfies 
$|\theta_{j+k}|\leq \gamma_{j+k}$.
\end{proposition}

\begin{proof}
If $|a|+|b|=0$, then the proposition is proved trivially, since both $a$ and 
$b$ are zero. 
Let us assume that $|a|+|b|\neq 0$ and let us define 
\begin{eqnarray}
\label{prop-thetajksum-ter1}
\theta_{j+k}
= \frac{a\theta_j + b \theta_k}{|a|+|b|}.
\end{eqnarray}
We have 
\begin{eqnarray}
|\theta_{j+k}|
&=& \left| \frac{a\theta_j + b \theta_k}{|a|+|b|}\right| \\
&\leq& \frac{|a||\theta_j| + |b| |\theta_k|}{|a|+|b|} \\
&\leq& \frac{|a| \gamma_j  + |b| \gamma_k}{|a|+|b|} \\
&\leq& \frac{|a| (\gamma_j + \gamma_k)  + |b| (\gamma_j + \gamma_k)}{|a|+|b|} \\
&\leq& \frac{|a| + |b|}{|a|+|b|} (\gamma_j + \gamma_k) \\
&\leq& \gamma_j + \gamma_k, \\
&\leq& \gamma_{j+k},
\end{eqnarray}
which concludes the proof.
\end{proof}

In some derivations, we are going to use fractions of expressions of 
the form $1+\delta_i$.
In this case, we can use the following proposition.

\begin{proposition}
(\emph{Fraction of $(1+\delta_i)$s})
\label{prop-thetajkdivision}
Assume that $j$ and $k$ are positive integers such that $ju<1$ and $ku<1$. 
Assume that $\delta_1,\delta_2,\ldots,\delta_j \in\RR$ are such that $|\delta_1|,|\delta_2|,\ldots,|\delta_j|\leq u$, 
and that $\delta_1^\prime,\delta_2^\prime,\ldots,\delta_k^\prime \in\RR$ are such that 
$|\delta_1^\prime|,|\delta_2^\prime|,\ldots,|\delta_k^\prime|\leq u$. 
Therefore, 
\begin{eqnarray}
\label{eq-thetajkdivision}
\frac{(1+\delta_1)(1+\delta_2)\cdots(1+\delta_j)}{(1+\delta_1^\prime)(1+\delta_2^\prime)\cdots(1+\delta_k^\prime)} 
&=& 1 + \theta_{j+k},
\end{eqnarray}
for some $\theta_{j+k}\in\RR$ which satisfies 
$|\theta_{j+k}|\leq \gamma_{j+k}$, where $\gamma_{j+k}$ is defined 
by \ref{def-gamman}.
\end{proposition}

\begin{proof}
Let us denote the products of $n$ terms $1+\delta_i$ by $P_n$, 
i.e. let $P_n$ be defined by  
\begin{eqnarray}
\label{def-deltaprodPn1}
P_j = (1+\delta_1)(1+\delta_2)\cdots(1+\delta_j).
\end{eqnarray}
Similarily, let us introduce 
\begin{eqnarray}
\label{def-deltaprodPn2}
P_k^\prime = (1+\delta_1^\prime)(1+\delta_2^\prime)\cdots(1+\delta_k^\prime).
\end{eqnarray}
We have to prove that  
\begin{eqnarray}
\label{eq-thetajkdivisionbis}
\frac{P_j}{P_k^\prime} &=& 1 + \theta_{j+k}.
\end{eqnarray}

It is straightforward to see that the proposition \ref{prop-productdelta} 
proves the case where $k=0$, i.e., the case where there are not terms 
in the denominator of \ref{eq-thetajkdivision}.

In order to prove the equation \ref{eq-thetajkdivisionbis}, we proceed by induction
on $k$. 
Let us assume that the equation \ref{eq-thetajkdivisionbis} is true for a given $k$, 
and let us prove that this is true for $k+1$, under the 
hypothesis $ju<1$ and $(k+1)u<1$. 
In other words, let us prove that 
\begin{eqnarray}
\label{eq-thetajkdivisionter}
\frac{P_j}{P_{k+1}^\prime} 
&=& 1 + \theta_{j+k+1},
\end{eqnarray}
for some $\theta_{j+k+1}$ which satisfies 
$|\theta_{j+k+1}|\leq \gamma_{j+k+1}$.

We obviously have $P_{k+1}^\prime=P_k^\prime (1+\delta_{k+1}^\prime)$, which implies 
\begin{eqnarray}
\label{eq-thetajkdivision1}
\frac{P_j}{P_{k+1}^\prime} 
&=& \frac{P_j}{P_k^\prime} \frac{1}{1+\delta_{k+1}^\prime}.
\end{eqnarray}
We recognize the fraction at the induction level $k$. 
Therefore, by the induction hypothesis, we have 
\begin{eqnarray}
\label{eq-thetajkdivision2}
\frac{P_j}{P_{k+1}^\prime} 
&=& \frac{1+\theta_{j+k}}{1+\delta_{k+1}^\prime}.
\end{eqnarray}
By hypothesis, we have $|\delta_{k+1}^\prime|<u<1$. 
Hence, we expand the fraction $\frac{1}{1+\delta_{k+1}^\prime}$ into its geometric series, 
and get
\begin{eqnarray}
\label{eq-thetajkdivision3}
\frac{P_j}{P_{k+1}^\prime} 
&=& (1+\theta_{j+k})(1-\delta_{k+1}^\prime+\delta_{k+1}^{\prime 2}-\delta_{k+1}^{\prime 3}+\ldots) \\
&=& 1-\delta_{k+1}^\prime+\delta_{k+1}^{\prime 2}-\delta_{k+1}^{\prime 3}+\ldots+\theta_{j+k}(1-\delta_{k+1}^\prime+\delta_{k+1}^{\prime 2}-\delta_{k+1}^{\prime 3}+\ldots). \\
&=& 1 + \theta_{j+k+1},
\end{eqnarray}
where $\theta_{j+k+1}$ satisfies the equation 
\begin{eqnarray}
\label{eq-thetajkdivision4}
\theta_{j+k+1}
&=&-\delta_{k+1}^\prime+\delta_{k+1}^{\prime 2}-\delta_{k+1}^{\prime 3}+\ldots+\theta_{j+k}(1-\delta_{k+1}^\prime+\delta_{k+1}^{\prime 2}-\delta_{k+1}^{\prime 3}+\ldots).
\end{eqnarray}
We are now going to bound $\theta_{j+k+1}$. 
To do this, we use the induction hypothesis on $\theta_{j+k}$, 
which states that $|\theta_{j+k}|\leq \gamma_{j+k}$, where $\gamma_{j+k}$ is defined 
by \ref{def-gamman}.
On the other hand, we use the hypothesis which gives a bound on $\delta_{k+1}^\prime$, i.e. we 
use that $|\delta_{k+1}^\prime|\leq u$. 
We plug these two inequalities into \ref{eq-thetajkdivision4} and get
\begin{eqnarray}
\label{eq-thetajkdivision5}
|\theta_{j+k+1}|
&\leq &u+u^2+u^3+\ldots+\frac{(j+k)u}{1-(j+k)u}(1+u+u^2+u^3+\ldots) \\
&\leq &u(1+u+u^2+\ldots)+\frac{(j+k)u}{1-(j+k)u}(1+u+u^2+u^3+\ldots) \\
&\leq &\left(u+\frac{(j+k)u}{1-(j+k)u}\right)(1+u+u^2+u^3+\ldots) \\
&\leq &\left(u+\frac{(j+k)u}{1-(j+k)u}\right)\frac{1}{1-u}.
\label{eq-thetajkdivision5-b}
\end{eqnarray}
The equation \ref{eq-thetajkdivision5-b} is valid because 
the hypothesis $u<1$ implies that we can use the geometric 
series for the fraction $\frac{1}{1-u}$.
We can simplify the left fraction and get
\begin{eqnarray}
\label{eq-thetajkdivision6}
|\theta_{j+k+1}|
&\leq &\frac{u(1-(j+k)u)+(j+k)u}{1-(j+k)u}\frac{1}{1-u} \\
&\leq &\frac{u-(j+k)u^2+(j+k)u}{(1-(j+k)u)(1-u)} \\
&\leq &\frac{(j+k+1)u-(j+k)u^2}{1-(j+k)u-u + (j+k)u^2} \\
&\leq &\frac{(j+k+1)u-(j+k)u^2}{1-(j+k+1)u + (j+k)u^2}.
\end{eqnarray}
We are almost done to prove the inequality $|\theta_{j+k+1}|\leq \gamma_{j+k+1}$, 
except the term $(j+k)u^2$, which appears 
both in the numerator and the denominator of the 
fraction. 
To conclude, all we have to do is to notice that 
\begin{eqnarray}
\label{eq-thetajkdivision7}
(j+k+1)u-(j+k)u^2\leq (j+k+1)u,
\end{eqnarray}
since $j$ and $k$ are both positive integers. 
On the other hand, we have $1-(j+k+1)u + (j+k)u^2 \geq 1-(j+k+1)u$. 
Finally, by assumption, we have $(j+k+1)u< 1$, which implies $1-(j+k+1)u>0$. 
Hence, we can invert and get
\begin{eqnarray}
\label{eq-thetajkdivision8}
\frac{1}{1-(j+k+1)u + (j+k)u^2} \leq \frac{1}{1-(j+k+1)u}. 
\end{eqnarray}
We combine the inequalities \ref{eq-thetajkdivision7} and \ref{eq-thetajkdivision8} 
into \ref{eq-thetajkdivision6}, and conclude the proof.
\end{proof}

In the following series of proofs, we are interested in 
fractions such as $\frac{1+\theta_k}{1+\theta_j}$. 


\begin{proposition}
(\emph{Fraction of $(1+\theta_i)$s})
\label{prop-1ptjkdivision}
Assume that $j$ and $k$ are positive integers such that $ju<1$ and $ku<1$. 
Moreover, we assume that $(k+j)u<1$ and $(k+2j)u<1$. 
Assume that $\theta_j,\theta_k \in\RR$ are such that $|\theta_k|\leq \gamma_k$ and
$|\theta_j|\leq \gamma_j$. 
Assume that $\gamma_j<1$. 
If $j\geq k$, then
\begin{eqnarray}
\label{eq-1ptjkdivision}
\frac{1+\theta_k}{1+\theta_j} &=& 1 + \theta_{k+2j},
\end{eqnarray}
for some $\theta_{k+2j}\in\RR$ which satisfies 
$|\theta_{k+2j}|\leq \gamma_{k+2j}$, where $\gamma_{k+2j}$ is defined 
by \ref{def-gamman}.
If $j\leq k$, then
\begin{eqnarray}
\label{eq-1ptjkdivision2}
\frac{1+\theta_k}{1+\theta_j} &=& 1 + \theta_{k+j},
\end{eqnarray}
for some $\theta_{k+j}\in\RR$ which satisfies 
$|\theta_{k+j}|\leq \gamma_{k+j}$, where $\gamma_{k+j}$ is defined 
by \ref{def-gamman}.
\end{proposition}

\begin{proof}
In the first part of the proof, we consider the general case 
where we do not make any assumption on $j$ or $k$ and 
leads to the inequality \ref{eq-1ptjkdivision}. 
Then we consider the special case where $j=k$, for which the 
calculation is very simple and immediatelly leads to \ref{eq-1ptjkdivision2}. 
Finally, we consider the case where $j\leq k$ and give a 
general proof of \ref{eq-1ptjkdivision2}.

We have 
\begin{eqnarray}
\label{eq-1ptjkdivision-1}
\frac{1+\theta_k}{1+\theta_j} &=& 1 + e,
\end{eqnarray}
where $e$ is defined by 
\begin{eqnarray}
\label{eq-1ptjkdivision-1b}
e = \frac{1+\theta_k}{1+\theta_j} - 1,
\end{eqnarray}
and we search a simplified expression for a bound of $e$.
We have 
\begin{eqnarray}
e 
&=& \frac{1+\theta_k - (1+\theta_j)}{1+\theta_j}, \\
&=& \frac{\theta_k - \theta_j}{1+\theta_j}.
\label{eq-1ptjkdivision-2}
\end{eqnarray}
On one hand, the hypothesis $|\theta_j|\leq \gamma_j$ implies $\theta_j \geq - \gamma_j$. 
Hence, 
\begin{eqnarray}
\label{eq-1ptjkdivision-4}
1+\theta_j \geq 1- \gamma_j.
\end{eqnarray}
The hypothesis $\gamma_j<1$ implies that $1-\gamma_j>0$. 
Hence both sides of the previous inequality are 
strictly positive and we invert this inequality. 
We get
\begin{eqnarray}
\label{eq-1ptjkdivision-5}
\frac{1}{1+\theta_j} \leq \frac{1}{1- \gamma_j}.
\end{eqnarray}
On the other hand, we obviously have 
\begin{eqnarray}
|\theta_k - \theta_j| 
&\leq& |\theta_k| + |\theta_j| \\
&\leq& \gamma_k + \gamma_j.
\label{eq-1ptjkdivision-6}
\end{eqnarray}
We plug \ref{eq-1ptjkdivision-5} and \ref{eq-1ptjkdivision-6} 
into \ref{eq-1ptjkdivision-2} and find 
\begin{eqnarray}
|e| 
&\leq& \frac{|\theta_k - \theta_j| }{1- \gamma_j} \\
&\leq& \frac{\gamma_k + \gamma_j}{1- \gamma_j}.
\label{eq-1ptjkdivision-7}
\end{eqnarray}
We are now going to search for simplified expressions 
for the numerator and the denominatory of the 
previous equation. 
We have 
\begin{eqnarray}
\gamma_k + \gamma_j 
&=& \frac{ku}{1-ku} + \frac{ju}{1-ju} \\
&=& \frac{ku(1-ju)+ju(1-ku)}{(1-ku)(1-ju)} \\
&=& \frac{ku-jku^2+ju-jku^2}{(1-ku)(1-ju)} \\
&=& \frac{(k+j)u-2jku^2}{(1-ku)(1-ju)}.
\label{eq-1ptjkdivision-8}
\end{eqnarray}
On the other hand, the expression $1-\gamma_j$ 
can be written as
\begin{eqnarray}
1-\gamma_j
&=& 1- \frac{ju}{1-ju} \\
&=& \frac{(1-ju)-ju}{1-ju} \\
&=& \frac{1-2ju}{1-ju}.
\label{eq-1ptjkdivision-9}
\end{eqnarray}
We plug the equations \ref{eq-1ptjkdivision-8} and \ref{eq-1ptjkdivision-9} 
into \ref{eq-1ptjkdivision-7} and get
\begin{eqnarray}
|e| 
&\leq& \frac{(k+j)u-2jku^2}{(1-ku)(1-ju)} \frac{1-ju}{1-2ju} \\
&\leq& \frac{(k+j)u-2jku^2}{(1-ku)(1-2ju)},
\label{eq-1ptjkdivision-10}
\end{eqnarray}
since the expression $1-ju$ can be simplified.
We now search for an expanded form of the product $(1-ku)(1-2ju)$. 
We have 
\begin{eqnarray}
|e| 
&\leq& \frac{(k+j)u-2jku^2}{1-ku-2ju+2jku^2} \\
&\leq& \frac{(k+j)u-2jku^2}{1-(k+2j)u+2jku^2}.
\label{eq-1ptjkdivision-11}
\end{eqnarray}
It is now easy to bound $e$, since $2jku^2\geq 0$. 
Hence, 
\begin{eqnarray}
|e| 
&\leq& \frac{(k+j)u}{1-(k+2j)u}.
\label{eq-1ptjkdivision-12}
\end{eqnarray}
We emphasize that the previous step is highly accurate, 
since $u$ is the unit roundoff. 
Indeed, this implies that $u^2$ is extremely small compared 
to $u$ in the inequality \ref{eq-1ptjkdivision-11}.
For any integers $j,k\geq 0$, we have $k+j\leq k+2j$, which, 
combined to the hypothesis $u>0$, implies 
\begin{eqnarray}
|e| 
&\leq& \frac{(k+2j)u}{1-(k+2j)u}.
\label{eq-1ptjkdivision-13}
\end{eqnarray}
The right hand side of the previous equation is $\gamma_{k+2j}$, 
which proves the equality \ref{eq-1ptjkdivision} in the general 
case.

In the second part of this proof, we consider the special case 
where $j=k$. 
We are going to check that this immediatelly leads to \ref{eq-1ptjkdivision2}. 
In the case where $j=k$, the inequality \ref{eq-1ptjkdivision-10} 
can be written
\begin{eqnarray}
|e| 
&\leq& \frac{2ju-2j^2u^2}{(1-ju)(1-2ju)} \\
&\leq& \frac{2ju(1-ju)}{(1-ju)(1-2ju)} \\
&\leq& \frac{2ju}{(1-2ju)} \\
&\leq& \gamma_{2j}.
\label{eq-1ptjkdivision-14}
\end{eqnarray}

Finally, we assume that $j\leq k$ and give a 
general proof of \ref{eq-1ptjkdivision2}. 
We have to prove that 
\begin{eqnarray}
\frac{(k+j)u-2jku^2}{1-(k+2j)u+2jku^2}  \leq \frac{(k+j)u}{1-(k+j)u}.
\label{eq-1ptjkdivision-15}
\end{eqnarray}
To do this, we prove that 
\begin{eqnarray}
\frac{(k+j)u}{1-(k+j)u} - \frac{(k+j)u-2jku^2}{1-(k+2j)u+2jku^2}  \geq 0.
\label{eq-1ptjkdivision-16}
\end{eqnarray}
In other words, we have to prove that 
\begin{eqnarray}
\frac{(k+j)u\left(1-(k+2j)u+2jku^2\right)-\left((k+j)u-2jku^2\right)\left(1-(k+j)u\right)}
     {\left(1-(k+j)u\right)\left((k+j)u-2jku^2\right)}  \geq 0.
\label{eq-1ptjkdivision-17}
\end{eqnarray}
By hypothesis, we have $(k+j)u<1$ and $(k+2j)u<1$ so that the denominator is 
positive. 
The numerator is equal to 
\begin{eqnarray}
&&(k+j)u\left(1-(k+2j)u+2jku^2\right)-\left((k+j)u-2jku^2\right)\left(1-(k+j)u\right)\\
&=& (k+j)u - (k+j)(k+2j)u^2+2(k+j)jku^3 \\
&&  - (k+j)u + (k+j)^2u^2 + 2jku^2 - 2(k+j)jku^3 \\
&=& - (k+j)(k+2j)u^2 + (k+j)^2u^2 + 2jku^2
\end{eqnarray}
since the terms $(k+j)u$ and $2(k+j)jku^3$ are eliminated.
We expand the previous equality and get 
\begin{eqnarray}
&&(-k^2-2jk-jk-2j^2 + k^2+2jk+j^2+2jk)u^2 \\
&=& (jk-j^2)u^2 \\
&=& j(k-j)u^2.
\label{eq-1ptjkdivision-18}
\end{eqnarray}
By hypothesis, $j\geq 0$ so that the numerator \ref{eq-1ptjkdivision-17} 
is positive if and only if $k-j\geq 0$, which concludes the proof.
\end{proof}



The figure \ref{fig-tableusefulproperrbounds} summarizes the 
results that we have proved in this section.

\begin{figure}
\begin{center}
\begin{tabular}{|l|l|l|}
\hline
        & \textbf{Hypothesis} & \textbf{Property} \\
\hline
1 & $j\leq k$ & $\gamma_j \leq \gamma_k$ \\
2 & $jku<1$ & $j \gamma_k \leq \gamma_{jk}$ \\
3 & & $(1+\delta_1)(1+\delta_2)\cdots(1+\delta_n) = 1 + \theta_n$ \\
4 & & $\gamma_j + \gamma_k + \gamma_j \gamma_k \leq \gamma_{j+k}$ \\
5 & & $\gamma_j + \gamma_k \leq \gamma_{j+k}$ \\
6 & & $\gamma_j + u \leq \gamma_{j+1}$ \\
7 & $(j+k)u<1$ & $(1+\theta_j)(1+\theta_k) = 1+\theta_{j+k}$ \\
8 & $a,b\in\RR$ & $a\theta_j + b\thetanp{j} = (|a|+|b|)\thetanpp{j}$ \\
9 & $a,b\geq 0$ & $a(1+\theta_j) + b(1+\thetanp{j}) = (a+b)(1+\thetanpp{j})$ \\
10 & $a,b\in\RR$ & $a\theta_j + b\theta_k = (|a|+|b|)\theta_{j+k}$ \\
11 & & $\frac{(1+\delta_1)(1+\delta_2)\cdots(1+\delta_j)}{(1+\delta_1^\prime)(1+\delta_2^\prime)\cdots(1+\delta_k^\prime)} = 1+\theta_{j+k}$ \\
12 & $j> k$ & $\frac{1+\theta_k}{1+\theta_j} = 1+\theta_{k+2j}$\\
13 & $j\leq k$ & $\frac{1+\theta_k}{1+\theta_j} = 1+\theta_{k+j}$\\
\hline
\end{tabular}
\end{center}
\caption{
Some useful properties for error bounds. 
In this table we assume that $u<1$. 
We assume that $j,k,n$ are three integers such that $j,k,n\geq 1$ 
and $ju,ku,nu<1$.
We denote by $\delta_j$ a real 
numbers such that $|\delta_j|\leq u$. 
We denote by $\theta_j$ a real number such that $|\theta_j|\leq \gamma_j$. 
}
\label{fig-tableusefulproperrbounds}
\end{figure}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{footnotesize}
\subsection{Exercises}
\label{section-useful-exercizes}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{exercise}[Products of $1+\delta$s]
\label{exe-productdelta}
The goal of this exercize is to experiment the proposition \ref{prop-productdelta}
numerically in Scilab. 
The \scivar{grand(m,n,"unf",a,b)} calling sequence produces a m-by-n 
matrix of doubles which are randomly sampled uniformly in the interval $[a,b]$. 
In order to experiment the proposition \ref{prop-productdelta}, we 
can pick random numbers $\delta_i$ in the interval $[-u,u]$, 
and compute the ratio $(1+\delta_1)(1+\delta_2)\ldots(1+\delta_n)/u$. 
Experiment this in Scilab with $n=5$.
\end{exercise}

\end{footnotesize}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Error bounds for complex arithmetic}
\label{section-errorcompar}


In this section, we prove error bounds for complex arithmetic, that 
is, we compute the relative error for the operations $x+y$, $x*y$ and 
$x/y$, when $x$ and $y$ are complex floating point numbers. 
These results are presented, for example, by Higham \cite{Higham:2002:ASN} for the 
complex addition and multiplication. 
For the complex division, however, the error bound that we present here 
is new, to our knowledge. 

The figure \ref{fig-tablecomplexerrorbounds} summarizes the 
results that we have proved in this section.

\begin{figure}
\begin{center}
\begin{tabular}{|l|l|}
\hline
\textbf{Operation} & \textbf{Error bound} \\
\hline
Addition, Subtraction & $u$ \\
Multiplication & $\sqrt{2}\gamma_2 \approx 2 \sqrt{2} u \approx 2.84 u$ \\
Division & $\gamma_6 \approx 6u$ \\
\hline
\end{tabular}
\end{center}
\caption{
Error bounds bounds for complex arithmetic.
}
\label{fig-tablecomplexerrorbounds}
\end{figure}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Standard arithmetic model}

In order to derive our error analysis, we must make some assumptions on the 
basic real arithmetic. 
Indeed, complex arithmetic is derived from the real arithmetic. 
We assume that the real arithmetic satisfies the following definition. 

\begin{definition}
(\emph{Standard arithmetic model})
\label{def-standardmodel}
We denote by $u\in\RR$ the unit roundoff. 
We denote by $F$ the set of floating point numbers in the current 
floating point system. 
The floating point system is associated with a standard 
arithmetic model if, for any $x,y\in F$, we have 
\begin{eqnarray}
\label{eq-errorcompar0}
fl(x \textrm{ op } y) = (x \textrm{ op } y)(1+\delta), 
\end{eqnarray}
where $\delta\in\RR$ is such that $|\delta|\leq u$, for 
$\textrm{ op }=+,-,*,/$.
\end{definition}

The IEEE 754 floating point arithmetic satisfies the 
definition \ref{def-standardmodel}. 
By contrast, a floating point arithmetic which does not 
make use of a guard digit may not satisfy this condition. 

We are going to review the error bounds for complex arithmetic 
operations one after the other. 
This might seem tedious at first. 
On the other hand, it let us feel the error analysis more progressively and 
makes us introduce the required tools more smoothly. 

We make the assumption that $x,y\in\CC$ are defined by
\begin{eqnarray}
\label{eq-errorcompar-assum0}
x = a+ib, \qquad y=c+id,
\end{eqnarray}
where $a,b,c,d\in\RR$.

This might be trivial, but notice that, in the 
equation \ref{eq-errorcompar-assum0}, the 
sum of the real and imaginary part is not implemented as a 
floating point sum: these just are the real and imaginary parts, 
so that there is no floating point error associated with this. 
Hence, we obviously have $fl(x)=fl(a)+ifl(b)$, for any 
$a,b\in\RR$.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Error bound for complex addition}

The first result that we can derive easily is the error bound for the 
addition.
\begin{proposition}
(\emph{Error bound for complex addition})
\label{prop-errorcompar-add}
We assume that the real arithmetic is standard, in the 
sense of the definition \ref{def-standardmodel}. 
Let us consider the sum of two complex numbers $x,y$, computed 
by 
\begin{eqnarray}
\label{eq-errorcompar-add0}
x+y = (a+c)+i(b+d).
\end{eqnarray}
Therefore, there exists some $\delta\in\CC$ such that 
\begin{eqnarray}
\label{eq-errorcompar-add1}
fl(x+y) = (x+y)(1+\delta), 
\end{eqnarray}
with 
\begin{eqnarray}
\label{eq-errorcompar-add2}
|\delta|\leq u.
\end{eqnarray}
\end{proposition}

The proof that we present is given by Higham in \cite{Higham:2002:ASN}.

\begin{proof}
By the definition of the complex sum \ref{eq-errorcompar-add0}, we 
have:
\begin{eqnarray}
\label{eq-errorcompar-add3}
fl(x+y) = fl(a+c) + i fl(b+d).
\end{eqnarray}
Then we apply the definition of the standard arithmetic 
model \ref{eq-errorcompar0} to the addition and get
\begin{eqnarray}
\label{eq-errorcompar-add4}
fl(x+y) = (a+c)(1+\delta_1) + i (b+d)(1+\delta_2),
\end{eqnarray}
for some $\delta_1,\delta_2\in\RR$ such that $|\delta_1|,|\delta_2|\leq u$. 
This implies 
\begin{eqnarray}
\label{eq-errorcompar-add5}
fl(x+y) 
&=& a+c+(a+c)\delta_1 + i (b+d) + i(b+d)\delta_2 \\
&=& x+y+(a+c)\delta_1 + i(b+d)\delta_2 \\
&=& x+y+e, \label{eq-errorcompar-add5b}
\end{eqnarray}
where the error $e\in\CC$ satisfies the equation 
\begin{eqnarray}
\label{eq-errorcompar-add6}
e&=& (a+c)\delta_1 + i(b+d)\delta_2.
\end{eqnarray}
We now compute the module of the error $e$ and get
\begin{eqnarray}
\label{eq-errorcompar-add7}
|e|^2
&=& (a+c)^2\delta_1^2 + (b+d)^2\delta_2^2 \\
&\leq& (a+c)^2 u^2 + (b+d)^2 u^2, 
\end{eqnarray}
from the bounds on $\delta_1$ and $\delta_2$. 
Hence, 
\begin{eqnarray}
\label{eq-errorcompar-add8}
|e|^2
&\leq& \left( (a+c)^2  + (b+d)^2 \right) u^2 \\
&\leq& |x+y|^2 u^2.
\end{eqnarray}
This implies 
\begin{eqnarray}
\label{eq-errorcompar-add9}
|e| &\leq& |x+y| u. 
\end{eqnarray}
At this point, we separate two cases, whether 
$x+y$ is a complex zero or nonzero. 

First, let us assume that $x+y=0$, therefore, the equation \ref{eq-errorcompar-add9} 
implies that $e=0$. 
Hence, the equation \ref{eq-errorcompar-add5b} implies that 
$fl(x+y) = x+y$. 
Therefore, the equation \ref{eq-errorcompar-add1} is satisfied 
with $\delta=0$. 

Second, let us assume that $x+y\neq 0$. 
Let us define $\delta\in\CC$ by the equation
\begin{eqnarray}
\label{eq-errorcompar-add10}
\delta = \frac{e}{x+y}. 
\end{eqnarray}
The inequality \ref{eq-errorcompar-add9} implies 
\begin{eqnarray}
\label{eq-errorcompar-add11}
|\delta| 
&=& \frac{|e|}{|x+y|} \\ 
&\leq& \frac{|x+y|u}{|x+y|} \\ 
&\leq& u. 
\end{eqnarray}
Then the equation \ref{eq-errorcompar-add5b} implies that 
\begin{eqnarray}
\label{eq-errorcompar-add12}
fl(x+y) 
&=& x+y+(x+y)\delta, \\
&=& (x+y)(1+\delta),
\end{eqnarray}
which concludes the proof.
\end{proof}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Error bound for complex multiplication}

Before considering the complex multiplication, we consider an easy intermediate 
property which will be useful in our next error bound.

\begin{proposition}
\label{prop-sumquad}
Assume that $a,b,c,d\in\RR$. 
Therefore,
\begin{eqnarray}
(|ac| + |bd|)^2 + (|ad| + |bc|)^2 \leq 2 (a^2+b^2)(c^2+d^2).
\label{eq-sumquad0}
\end{eqnarray}
\end{proposition}

\begin{proof}
We have 
\begin{eqnarray}
(|ac| + |bd|)^2 + (|ad| + |bc|)^2 
& = & a^2 c^2 + 2|abcd| + b^2 d^2 +  a^2 d^2 + 2|abcd| + b^2 c^2 \\
& = & a^2 (c^2 + d^2 ) + b^2 (c^2 + d^2 ) + 4|abcd|  \\
& = & (a^2 + b^2 ) (c^2 + d^2 ) + 4|abcd|.
\label{eq-sumquad1}
\end{eqnarray}
All we have to do is to prove that
\begin{eqnarray}
4|abcd| & \leq & (a^2 + b^2 ) (c^2 + d^2 ).
\label{eq-sumquad2}
\end{eqnarray}
Indeed, if we plug the previous inequality into \ref{eq-sumquad1}, 
this immediately implies \ref{eq-sumquad0}.

The remaining work is to prove the inequality \ref{eq-sumquad2}. 
This is easy, since
\begin{eqnarray}
0 \leq (|ac|-|bd|)^2 + (|ad|-|bd|)^2.
\label{eq-sumquad3}
\end{eqnarray}
The previous inequality implies 
\begin{eqnarray}
0 \leq a^2 c^2 - 2 |abcd| + b^2 d^2 + a^2 d^2 - 2|abcd| + b^2 c^2
\label{eq-sumquad4}
\end{eqnarray}
Therefore, 
\begin{eqnarray}
0 \leq (a^2 + b^2) (c^2 + d^2) - 4 |abcd|, \label{eq-sumquad5}
\end{eqnarray}
which proves that \ref{eq-sumquad2} is true and magically concludes this proof.
\end{proof}


We now consider the case of the complex multiplication. 

\begin{proposition}
(\emph{Error bound for complex multiplication})
\label{prop-errorcompar-mul}
We assume that the real arithmetic is standard, in the 
sense of the definition \ref{def-standardmodel}. 
Let us consider the product of two complex numbers $x,y$, computed 
by 
\begin{eqnarray}
\label{eq-errorcompar-mul0}
x*y = (ac-bd) + i(ad+bc).
\end{eqnarray}
Therefore, there exists some $\delta\in\CC$ such that 
\begin{eqnarray}
\label{eq-errorcompar-mul1}
fl(x*y) = (xy)(1+\delta), 
\end{eqnarray}
with 
\begin{eqnarray}
\label{eq-errorcompar-mul2}
|\delta|\leq \sqrt{2} \gamma_2,
\end{eqnarray}
where $\gamma_2$ is defined by \ref{def-gamman}.
\end{proposition}

The proof that we present is given by Higham in \cite{Higham:2002:ASN}.

\begin{proof}
We consider the equation \ref{eq-errorcompar-mul0} and apply the standard 
model \ref{def-standardmodel} for the subtraction, then for the product. 
We get:
\begin{eqnarray}
fl(x*y) 
&=& fl(ac-bd) + i fl(ad+bc)\\
&=& (fl(ac)-fl(bd))(1+\delta_1) + i (fl(ad)+fl(bc))(1+\delta_2)\\
&=& (ac(1+\delta_3)-bd(1+\delta_4))(1+\delta_1) \\
& & + i (ad(1+\delta_5)+bc(1+\delta_6))(1+\delta_2),\\
\label{eq-errorcompar-mul3}
\end{eqnarray}
for some $\delta_i\in\RR$ such that $|\delta_i|\leq u$, for $i=1,2,\ldots,6$.
The equation \ref{eq-errorcompar-mul3} implies 
\begin{eqnarray}
fl(x*y) 
&=& (ac(1+\delta_3)(1+\delta_1)-bd(1+\delta_4)(1+\delta_1)) \\
& & + i (ad(1+\delta_5)(1+\delta_2)+bc(1+\delta_6)(1+\delta_2)).
\label{eq-errorcompar-mul4}
\end{eqnarray}
The previous equation let us discover products of terms $(1+\delta_i)$. 
This is why we apply the proposition \ref{prop-productdelta}, which 
implies that there are four $\theta_2,\thetanp{2},\thetanpp{2},
\thetanppp{2}\in\RR$ such that
\begin{eqnarray}
fl(x*y) 
&=& (ac(1+\theta_2)-bd(1+\thetanp{2})) 
 + i (ad(1+\thetanpp{2})+bc(1+\thetanppp{2})),
\label{eq-errorcompar-mul5}
\end{eqnarray}
where
\begin{eqnarray}
|\theta_2|,|\thetanp{2}|,|\thetanpp{2}|,
|\thetanppp{2}|\leq \gamma_2.
\label{eq-errorcompar-mul6}
\end{eqnarray}
The equation \ref{eq-errorcompar-mul5} implies 
\begin{eqnarray}
fl(x*y) &=& xy + e, \label{eq-errorcompar-mul7}
\end{eqnarray}
where $e$ is defined by the equation
\begin{eqnarray}
e = ac\theta_2 -bd\thetanp{2}  
+ i (ad\thetanpp{2}+bc \thetanppp{2}).
\label{eq-errorcompar-mul8}
\end{eqnarray}
The previous equation implies 
\begin{eqnarray}
e^2 = (ac\theta_2 - bd\thetanp{2})^2  
+ (ad\thetanpp{2} + bc \thetanppp{2})^2.
\label{eq-errorcompar-mul9}
\end{eqnarray}
We now bound each of the terms in the right 
hand side of \ref{eq-errorcompar-mul9}. 
We have
\begin{eqnarray}
|ac\theta_2 - bd\thetanp{2}| 
&\leq &|ac||\theta_2| + |bd||\thetanp{2}|, \\
|ad\thetanpp{2} + bc \thetanppp{2}|
&\leq& |ad||\thetanpp{2}| + |bc| |\thetanppp{2}|.
\end{eqnarray}
We can bound the $\theta_2$ terms by the inequality \ref{eq-errorcompar-mul6}, 
which implies 
\begin{eqnarray}
|ac\theta_2 - bd\thetanp{2}| 
&\leq &|ac|\gamma_2 + |bd|\gamma_2, \\
&\leq &(|ac| + |bd|)\gamma_2, \label{eq-errorcompar-mul10} \\
|ad\thetanpp{2} + bc \thetanppp{2}|
&\leq& |ad|\gamma_2 + |bc| \gamma_2 \\
&\leq& (|ad| + |bc|) \gamma_2 \label{eq-errorcompar-mul11}
\end{eqnarray}
We plug the inequalities \ref{eq-errorcompar-mul10} and 
\ref{eq-errorcompar-mul11} into \ref{eq-errorcompar-mul9} and get
\begin{eqnarray}
e^2 
&\leq & (|ac| + |bd|)^2\gamma_2^2 + (|ad| + |bc|)^2 \gamma_2^2 \\
&\leq & \left( (|ac| + |bd|)^2 + (|ad| + |bc|)^2 \right) \gamma_2^2.
\label{eq-errorcompar-mul12}
\end{eqnarray}
We now use the proposition \ref{prop-sumquad}, which 
implies 
\begin{eqnarray}
e^2 &\leq & 2 (a^2+b^2)(c^2+d^2) \gamma_2^2. \label{eq-errorcompar-mul13}
\end{eqnarray}
We recognize in $a^2+b^2$ the square of the modulus of 
$x$ and in $c^2+d^2$ the square of the modulus of $y$. 
Hence, 
\begin{eqnarray}
e^2 &\leq & 2 |x|^2 |y|^2 \gamma_2^2. \label{eq-errorcompar-mul14}
\end{eqnarray}
Therefore, 
\begin{eqnarray}
|e| &\leq & \sqrt{2} |x| |y| \gamma_2. \label{eq-errorcompar-mul15}
\end{eqnarray}
We now consider two cases, depending if $xy$ is zero or nonzero. 

If $xy=0$, then the inequality \ref{eq-errorcompar-mul15} implies that 
$e=0$.
Hence, the equation \ref{eq-errorcompar-mul7} shows that 
$fl(x*y)=xy$ exactly. 
Therefore, the equation \ref{eq-errorcompar-mul1} is satisfied with 
$\delta=0$, which concludes the first part of the proof.

On the other hand, if $xy\neq 0$, we introduce 
\begin{eqnarray}
\delta = \frac{e}{xy}. \label{eq-errorcompar-mul16}
\end{eqnarray}
The inequality \ref{eq-errorcompar-mul15} implies that 
$|\delta|\leq \sqrt{2} \gamma_2$.
The equation \ref{eq-errorcompar-mul1}, combined with \ref{eq-errorcompar-mul16}, 
implies that $fl(x*y)=xy+xy\delta = xy(1+\delta)$, 
which concludes the proof.
\end{proof}

In order to get a rough idea of what means this error bound, 
we can see that $\sqrt{2}\gamma_2 < 2.84 u$. 
\lstset{language=scilabscript}
\begin{lstlisting}
-->sqrt(2)*gamman(2)/u
 ans  =
    2.8284271  
\end{lstlisting}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Other error bounds for complex multiplication}
\label{sec-otherboundmul}

In \cite{BRENT:2007:INRIA-00120352:2}, Brent, Percival and Zimmerman 
prove an accurate error bound for the complex multiplication. 
They consider $u=\frac{1}{2}\epsilon$, the unit roundoff.
Therefore, if $u< 2^{-5}$, then, provided that no overflow 
or underflow occurs, then 
\begin{eqnarray}
fl(x*y) = (xy)(1+\delta), 
\end{eqnarray}
with 
\begin{eqnarray}
\label{eq-errorcompar-mulbrent}
|\delta|\leq \sqrt{5}u.
\end{eqnarray}
This error bound is very close to $\sqrt{5}u\approx 2.24 u$. 

The authors emphasize \cite{BRENT:2007:INRIA-00120352:2} that their 
error bound $\sqrt{5}u$ is tighter than the error bound given 
by \ref{eq-errorcompar-mul2}, which is very close to $2\sqrt{2}u\approx 2.84 u$.
Their proof is relatively more complicated than Higham's and will not 
be presented here.

% Worst case: Corollary 5
% (3*(1+4*2^-53)/4+i*3/4)*(2*(1+7*2^-53)/3+i*2*(1+2^-53)/3)
% a0=(3/4)*(1+4*u)
% b0=3/4
% a1=(2/3)*(1+7*u)
% b1=(2/3)*(1+u)
% c = (a0+%i*b0)*(a1+%i*b1)
% e = 5.551115123125784427e-16 + 1.000000000000000666 * %i
% abs(c-e)/abs(e)/u
%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Error bound for complex division}

We can finally consider the objective of this section, the error bound 
for the naive algorithm of the complex division. 
To our knowledge, the proof associated with this error bound is 
new.

\begin{proposition}
(\emph{Error bound for complex division})
\label{prop-errorcompar-div}
We assume that the real arithmetic is standard, in the 
sense of the definition \ref{def-standardmodel}. 
Let us consider the division of two complex numbers $x,y$, computed 
by 
\begin{eqnarray}
\label{eq-errorcompar-div0}
x/y = \frac{ac+bd}{c^2+d^2} + i\frac{bc-ad}{c^2+d^2}.
\end{eqnarray}
Therefore, there exists some $\theta_6\in\CC$ such that 
\begin{eqnarray}
\label{eq-errorcompar-div1}
fl(x/y) = (x/y)(1+\theta_6), 
\end{eqnarray}
with 
\begin{eqnarray}
\label{eq-errorcompar-div2}
|\theta_6|\leq \gamma_6,
\end{eqnarray}
where $\gamma_6$ is defined by \ref{def-gamman}.
\end{proposition}

\begin{proof}
We first compute an error bound for the denominator $c^2+d^2$. 
By definition of the standard model \ref{def-standardmodel}, we have 
\begin{eqnarray}
fl(c^2+d^2)
&=&(fl(c^2)+fl(d^2))(1+\delta_1) \\
&=&(c^2(1+\delta_2)+d^2(1+\delta_3))(1+\delta_1) \\
&=&c^2(1+\delta_2)(1+\delta_1)+d^2(1+\delta_3)(1+\delta_1),
\label{eq-errorcompar-div3}
\end{eqnarray}
for some $\delta_1,\delta_2,\delta_3\in\RR$ such that 
$|\delta_1|,|\delta_2|,|\delta_3|\leq u$. 
The proposition \ref{prop-productdelta} then implies that there are 
two $\theta_2,\thetanp{2}\in\RR$ such that 
\begin{eqnarray}
fl(c^2+d^2)
&=&c^2(1+\thetan{2})+d^2(1+\thetanp{2}),
\label{eq-errorcompar-div4}
\end{eqnarray}
where $|\thetan{2}|,|\thetanp{2}|\leq \gamma_2$.
Since $c^2$ and $d^2$ are both positive, we can apply the proposition 
\ref{prop-thetajksum-bis}, which implies that there 
exists $\thetanpp{2}\in\RR$ such that
\begin{eqnarray}
fl(c^2+d^2)
&=&(c^2+d^2)(1+\thetanpp{2}),
\label{eq-errorcompar-div5}
\end{eqnarray}
with $|\thetanpp{2}|\leq \gamma_2$.

We then apply the error bound for the complex product, that is, 
we apply the proposition \ref{prop-errorcompar-mul}.
By definition, we have 
\begin{eqnarray}
fl(x/y)
&=& fl\left( \frac{(a+ib)(c-id)}{c^2+d^2}\right).
\label{eq-errorcompar-div10}
\end{eqnarray}
Hence, 
\begin{eqnarray}
fl(x/y)
&=& \frac{fl((a+ib)(c-id))}{fl(c^2+d^2)}(1+\delta_1),
\end{eqnarray}
where $|\delta_1|\leq u$, because we divide separately the 
real and imaginary parts by the real number $c^2+d^2$. 
This implies 
\begin{eqnarray}
fl(x/y)
&=& \frac{fl((a+ib)(c-id))}{(c^2+d^2)(1+\thetanpp{2})}(1+\delta_1),
\end{eqnarray}
where $|\thetanpp{2}|\leq \gamma_2$, 
because of the equality \ref{eq-errorcompar-div5}.
We now apply the proposition \ref{prop-errorcompar-mul} 
to the complex multiplication $(a+ib)(c-id)$ and get 
\begin{eqnarray}
fl(x/y)
&=& \frac{(a+ib)(c-id)(1+\delta)}{(c^2+d^2)(1+\thetanpp{2})}(1+\delta_1), \\
\label{eq-errorcompar-div10b}
\end{eqnarray}
where $|\delta|\leq \sqrt{2} \gamma_2$. 
Therefore, 
\begin{eqnarray}
fl(x/y)
&=& (x/y)\frac{(1+\delta)(1+\delta_1)}{1+\thetanpp{2}}.
\label{eq-errorcompar-div11}
\end{eqnarray}
We now use the proposition \ref{prop-basicgamman} in order to 
simplify the error terms. 
We have 
\begin{eqnarray}
|\delta| \leq \sqrt{2} \gamma_2 \leq \gamma_{2\sqrt{2}} = 
   \gamma_{2.82\ldots} < \gamma_3.
\label{eq-errorcompar-div11b}
\end{eqnarray}
Let us introduce $\theta_3=\delta$. 
We obviously have $|\theta_3|=|\delta|\leq \gamma_3$. 
Let us introduce $\theta_1=\delta_1$. 
We obviously have $|\theta_1|=|\delta_1|\leq u< \gamma_1$. 
Hence, we can write
\begin{eqnarray}
fl(x/y)
&=& (x/y)\frac{(1+\theta_3)(1+\theta_1)}{1+\thetanpp{2}},
\label{eq-errorcompar-div12}
\end{eqnarray}
where $|\theta_3|\leq \gamma_3$, $|\theta_1|\leq \gamma_1$ and 
$|\thetanpp{2}|\leq \theta_2$.
We first apply the proposition \ref{prop-thetajkprod}, which bounds a 
product of two $(1+\theta_j)$s. 
Hence, 
\begin{eqnarray}
fl(x/y)
&=& (x/y)\frac{1+\theta_4}{1+\thetanpp{2}},
\label{eq-errorcompar-div13}
\end{eqnarray}
where $|\theta_4|\leq \gamma_4$. 
We now apply the proposition \ref{prop-1ptjkdivision}, which bounds 
a ratio of $(1+\theta_i)$s in the case where $j\leq k$.
Hence, 
\begin{eqnarray}
fl(x/y)
&=& (x/y)(1+\theta_6),
\label{eq-errorcompar-div14}
\end{eqnarray}
where $|\theta_6|\leq \gamma_6$, and concludes the proof.
\end{proof}

We could easily integrate the results for the error bound of the complex 
multiplication \cite{BRENT:2007:INRIA-00120352:2} into 
the proof of the proposition \ref{prop-errorcompar-div}.
Their result would lead to the equation \ref{eq-errorcompar-div10b} where 
$\delta$ is so that $|\delta| \leq \sqrt{5} u$. 
However, the inequalities \ref{eq-errorcompar-div11b} are not tight 
enough to take advantage of this accurate bound, because 
our method is based on $|\delta| \leq \sqrt{5} u < \gamma_{2.23...} < \gamma_3$. 
The same method would then lead to the same result. 

All in all, it appears that the inequalities that we derive in \ref{eq-errorcompar-div11b} 
are much less tight than possible. 
A possible method may be to extend the properties of $\gamma_n$ to 
non-integer values of $n$. 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Other error bounds for the naive complex division algorithm}
\label{sec-otherbounddiv}

What makes the proposition \ref{prop-errorcompar-div} interesting is that it is 
simply based on the error bound for the complex multiplication. 
If we integrate the error bound $\sqrt{5}u$ is integrated in the proof, therefore the 
more accurate $(\sqrt(5)+1+2)u=(\sqrt{5}+3)u\approx 5.24u$ can be found.

In \cite{MullerEtAl2010}, Muller et al. present in the section 4.5.3 "Complex division", 
an error bound for the naive algorithm of the complex division. 
They assume that no underflow or overflow occur and 
that the default IEEE round-to-nearest rounding mode is 
used. 
They assume that the unit roundoff $u$ satisfies 
$u < 1/8$.
Then, 
\begin{eqnarray}
|fl(x/y) - x/y| \leq 5 \sqrt{2} (1+6u)u |x/y|.
\end{eqnarray}
The proof is given in \cite{MullerEtAl2010}.
This bound is very close to $5 \sqrt{2} u \approx 7.07 u$. 
This bound is higher than the bound $\gamma_6 \approx 6u$ presented in the 
proposition \ref{prop-errorcompar-div}.

In \cite{Higham:2002:ASN}, Higham provides an error bound for the 
naive complex division algorithm. 
Assume that $u$ is a positive real number, and that $\delta$ is a 
complex number such that $|\delta|\leq u$.
Then, for $n=1,2,\ldots$ such that $nu< 1$, let us define $\gamma_n$ by 
\begin{eqnarray}
\gamma_n = \frac{nu}{1-nu}.
\end{eqnarray}
In the section 3.6 "Complex Arithmetic" of \cite{Higham:2002:ASN}, Higham 
states that 
\begin{eqnarray}
fl(x/y) = (x/y)(1+\delta),
\end{eqnarray}
where $|\delta|\leq \sqrt{2} \gamma_4\approx 4 \sqrt{2} u \approx 5.65u$. 
Unfortunately, the proof has a small technical problem which makes the result wrong. 
A revised proof based on the same technique is presented in the exercize \ref{exe-diverrorbis}, where 
the error bound is $\sqrt{2}\gamma_5\approx 5 \sqrt{2} u \approx 7.07 u$. 
This is the same bound achieved by Muller et al in \cite{MullerEtAl2010}.

Higham emphasizes that $\delta$ is a complex number, so that 
we cannot conclude from the error bound that the real and 
imaginary parts are obtained to high relative accuracy -- only that 
they are obtained to high accuracy relative to $|fl(x/y)|$.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Error bounds for Smith's complex division algorithm}

An analysis of Hough, cited by Coonen \cite{1667289} and Stewart \cite{214414} 
shows that when Smith's algorithm works, it returns a computed value $\overline{z}$
satisfying
\begin{eqnarray}
|fl(x/y) - x/y| \leq \eta |z|,
\end{eqnarray}
where $z$ is the exact complex division result and $\eta$ is of the same order of magnitude 
as the unit roundoff $u$ for the arithmetic in question. 

In \cite{Dem84}, Demmel analyzes Smith's algorithm. 
Under the hypothesis that graceful underflow is available, Demmel states that,  
if both $|x|$ and $|y|$ are greater than $\alpha$, then
\begin{eqnarray}
fl(x/y) = (x/y)(1+e_r)+e_a,
\end{eqnarray}
where the relative error $e_r$ is 
\begin{eqnarray}
|e_r| \leq 7\sqrt{2} \epsilon,
\end{eqnarray}
with $\epsilon$ the machine epsilon, and the absolute error is 
\begin{eqnarray}
e_a = \sqrt{2} \epsilon \alpha.
\end{eqnarray}

In the section 3.6 "Complex Arithmetic" of \cite{Higham:2002:ASN}, Higham 
states that the error in Smith's algorithm is
\begin{eqnarray}
fl(x/y) = (x/y)(1+\delta),
\end{eqnarray}
where $|\delta|\leq \sqrt{2} \gamma_7$. 
This error bound is very close to $7 \sqrt{2} u \approx 9.90 u$.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Exercizes}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{exercise}[Norm of $x/y$]
\label{exe-normdiv}
Assume that $a,b,c,d\in\RR$ and consider $x=a+ib$ and $y=c+id$. 
Prove that 
\begin{eqnarray}
|x/y|^2=\frac{|x|^2}{|y|^2}.
\label{prop-normdiv1}
\end{eqnarray}
\end{exercise}

\begin{exercise}[Another error bound for $x/y$]
\label{exe-diverrorbis}
The goal of this exercize is to prove another error bound for the complex division.
We assume that the real arithmetic is standard, in the 
sense of the definition \ref{def-standardmodel}. 
Let us consider the division of two complex numbers $x,y$, computed 
by 
\begin{eqnarray}
\label{eq-diverrorbis-div0}
x/y = \frac{ac+bd}{c^2+d^2} + i\frac{bc-ad}{c^2+d^2}.
\end{eqnarray}
Therefore, there exists some $\delta\in\CC$ such that 
\begin{eqnarray}
\label{eq-diverrorbis-div1}
fl(x/y) = (x/y)(1+\delta), 
\end{eqnarray}
with 
\begin{eqnarray}
\label{eq-diverrorbis-div2}
|\delta|\leq \sqrt{2} \gamma_5,
\end{eqnarray}
where $\gamma_5$ is defined by \ref{def-gamman}. 
To perform this exercize, prove the following intermediate 
results. 
\begin{enumerate}
\item Prove that 
\begin{eqnarray}
fl(Re(x/y))
&=& Re(x/y) + e_1,
\end{eqnarray}
where the error $e_1$ is defined by 
\begin{eqnarray}
e_1 = \frac{ac\theta_{5}+bd\thetanp{5}}{c^2+d^2},
\end{eqnarray}
for some $\theta_{5},\thetanp{5}\in\RR$. 
\item Then prove that 
\begin{eqnarray}
|e_1| 
&\leq& \frac{|ac|+|bd|}{c^2+d^2} \gamma_{5}.
\end{eqnarray}
\item Similarily, compute the error $e_2$ for the imaginary part $Im(x/y)$.
\item Notice that 
$$
|fl(x/y-x/y|^2 = | e_1|^2 + |e_2 |^2
$$
and use the proposition \ref{prop-sumquad} to prove that 
\begin{eqnarray}
|fl(x/y-x/y|^2 &\leq& \frac{|x|^2}{|y|^2} 2\gamma_{5}^2.
\end{eqnarray}
\item Use the exercize \ref{exe-normdiv} and conclude.
\end{enumerate}
\end{exercise}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Notes and references}
In \cite{Dunham:1989:ICA:74654.74655}, Dunham shows that the use of 
double precision in single precision complex multiplication and 
division can significantly reduce rounding errors in these operations. 
Use of double precision accumulation of inner products in complex 
multiplication gives very close to the best possible error bound.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Acknowledgements}
We express our gratitude to Nicolas Higham for his advices. 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\newpage
\begin{footnotesize}
\section{Answers}

\subsection{Answers for section \ref{section-useful-exercizes}}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{answer}{\ref{exe-productdelta}}{Products of $1+\delta$s}
The following script experiments the proposition \ref{prop-productdelta}
numerically in Scilab. 
We use $n=5$. 
\lstset{language=scilabscript}
\begin{lstlisting}
stacksize("max")
u=%eps/2;
for N = floor(logspace(1,6,10))
  d = grand(N,5,'unf',-1,1).*u;
  d = abs(prod(1+d,"c")-1)/u;
  mprintf("%d %f\n",N,max(d))
end
\end{lstlisting}
The previous script produces the following output.
\lstset{language=scilabscript}
\begin{lstlisting}
10 4.000000
35 3.000000
129 4.000000
464 4.000000
1668 4.000000
5994 5.000000
21544 5.000000
77426 5.000000
278255 5.000000
1000000 5.000000
\end{lstlisting}
\end{answer}

\subsection{Answers for section \ref{section-errorcompar}}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{answer}{\ref{exe-normdiv}}{Norm of $x/y$}
By definition, we have
\begin{eqnarray}
|x/y|^2
&=& \left(\frac{ac+bd}{c^2+d^2}\right)^2 + \left(\frac{bc-ad}{c^2+d^2}\right)^2 \\
&=& \frac{a^2c^2+2abcd+b^2d^2+b^2c^2-2abcd+a^2d^2}{(c^2+d^2)^2} \\
&=& \frac{a^2c^2+b^2d^2+b^2c^2+a^2d^2}{(c^2+d^2)^2} \\
&=& \frac{a^2(c^2+d^2)+b^2(c^2+d^2)}{(c^2+d^2)^2} \\
&=& \frac{(a^2+b^2)(c^2+d^2)}{(c^2+d^2)^2} \\
&=& \frac{a^2+b^2}{c^2+d^2} \\
&=& \frac{|x|^2}{|y|^2},
\end{eqnarray}
which concludes the proof.
\end{answer}

\begin{answer}{\ref{exe-diverrorbis}}{Another error bound for $x/y$}
We now use the approach used by Higham in \cite{Higham:2002:ASN} to derive 
an error bound for the complex division.
We have 
\begin{eqnarray}
fl(Re(x/y))
&=& fl\left(\frac{ac+bd}{c^2+d^2}\right)\\
&=& \frac{fl(ac+bd)}{fl(c^2+d^2)}(1+\delta_1)\\
&=& \frac{(fl(ac)+fl(bd))(1+\delta_2)}{(c^2+d^2)(1+\thetanpp{2})}(1+\delta_1)\\
&=& \frac{(ac(1+\delta_3)+bd(1+\delta_4))(1+\delta_2)}{(c^2+d^2)(1+\thetanpp{2})}(1+\delta_1), \\
&=& \frac{ac(1+\delta_3)(1+\delta_2)(1+\delta_1)+bd(1+\delta_4)(1+\delta_2)(1+\delta_1)}{(c^2+d^2)(1+\thetanpp{2})},
\label{eq-errorcompar-div6}
\end{eqnarray}
where $\delta_1,\delta_2,\delta_3,\delta_4\in\RR$ are such that 
$|\delta_1|,|\delta_2|,|\delta_3|,|\delta_4|\leq u$.
The proposition \ref{prop-productdelta} then implies that there are 
two $\thetanppp{3},\thetanpppp{3}\in\RR$ such that 
\begin{eqnarray}
fl(Re(x/y))
&=& \frac{ac(1+\thetanppp{3})+bd(1+\thetanpppp{3})}{(c^2+d^2)(1+\thetanpp{2})},
\label{eq-errorcompar-div7}
\end{eqnarray}
where $|\thetanppp{3}|,|\thetanpppp{3}|\leq \gamma_3$. 
The proposition \ref{prop-1ptjkdivision} implies that $(1+\thetanppp{3})/(1+\thetanpp{2})=1+\theta_5$ and 
$(1+\thetanpppp{3})/(1+\thetanpp{2})=1+\thetanp{5}$ for some $\theta_5,\thetanp{5}\in\RR$. 
Therefore
\begin{eqnarray}
fl(Re(x/y))
&=& \frac{ac(1+\theta_{5})+bd(1+\thetanp{5})}{c^2+d^2} \\
&=& \frac{ac+bd}{c^2+d^2} + \frac{ac\theta_{5}+bd\thetanp{5}}{c^2+d^2} \\
&=& Re(x/y) + e_1,
\label{eq-errorcompar-div20}
\end{eqnarray}
where the error $e_1$ is defined by 
\begin{eqnarray}
e_1 = \frac{ac\theta_{5}+bd\thetanp{5}}{c^2+d^2}.
\label{eq-errorcompar-div21}
\end{eqnarray}
We take the absolute value of $e_1$ and get
\begin{eqnarray}
|e_1| 
&\leq& \frac{|ac|\gamma_{5}+|bd|\gamma_{5}}{c^2+d^2} \\
&\leq& \frac{|ac|+|bd|}{c^2+d^2} \gamma_{5}
\label{eq-errorcompar-div22}
\end{eqnarray}
Similarily, the imaginary part $Im(x/y)$ is so that
\begin{eqnarray}
fl(Im(x/y))
&=& Im(x/y) + e_2,
\label{eq-errorcompar-div23}
\end{eqnarray}
where the error $e_2$ is such that
\begin{eqnarray}
|e_2| 
&\leq& \frac{|bc|+|ad|}{c^2+d^2} \gamma_{5}.
\label{eq-errorcompar-div24}
\end{eqnarray}
Therefore, the error for the floating point representation of $x/y$ is 
\begin{eqnarray}
|fl(x/y)-x/y|^2
&=& |fl(Re(x/y)) + i fl(Im(x/y))-x/y|^2 \\
&=& |Re(x/y) + e_1 + i (Im(x/y) + e_2) -x/y|^2 \\
&=& | e_1 + i e_2 |^2 \\
&=& | e_1|^2 + |e_2 |^2 \\
&\leq& \frac{(|ac|+|bd|)^2}{(c^2+d^2)^2} \gamma_{5}^2 + \frac{(|bc|+|ad|)^2}{(c^2+d^2)^2} \gamma_{5}^2. \\
&\leq& \frac{(|ac|+|bd|)^2 + (|bc|+|ad|)^2}{(c^2+d^2)^2} \gamma_{5}^2.
\label{eq-errorcompar-div25}
\end{eqnarray}
The proposition \ref{prop-sumquad} implies 
\begin{eqnarray}
|fl(x/y)-x/y|^2
&\leq& \frac{2(a^2+b^2) (c^2+d^2)}{(c^2+d^2)^2} \gamma_{5}^2 \\
&\leq& \frac{(a^2+b^2)}{c^2+d^2} 2\gamma_{5}^2 \\
&\leq& \frac{|x|^2}{|y|^2} 2\gamma_{5}^2.
\label{eq-errorcompar-div26}
\end{eqnarray}
Finally, the proposition \ref{prop-normdiv1} implies 
\begin{eqnarray}
|fl(x/y)-x/y|^2
&\leq& |x/y|^2 2\gamma_{5}^2.
\label{eq-errorcompar-div27}
\end{eqnarray}
which implies
\begin{eqnarray}
|fl(x/y)-x/y|
&\leq& |x/y| \sqrt{2}\gamma_{5}.
\label{eq-errorcompar-div28}
\end{eqnarray}
\end{answer}


\end{footnotesize}

\bibliographystyle{plain}
\bibliography{improved_cdiv}


\end{document}

